diff --git a/app/test/test_cryptodev.c b/app/test/test_cryptodev.c
index 4eab8269e2..17444d8fb7 100644
--- a/app/test/test_cryptodev.c
+++ b/app/test/test_cryptodev.c
@@ -7195,6 +7195,30 @@ test_zuc_auth_cipher_verify_test_case_1_oop_sgl(void)
 		&zuc_auth_cipher_test_case_1, OUT_OF_PLACE, 1);
 }
 
+static int
+test_zuc256_encryption_test_case_1(void)
+{
+	return test_zuc_encryption(&zuc256_test_case_cipher_1);
+}
+
+static int
+test_zuc256_encryption_test_case_2(void)
+{
+	return test_zuc_encryption(&zuc256_test_case_cipher_2);
+}
+
+static int
+test_zuc256_authentication_test_case_1(void)
+{
+	return test_zuc_authentication(&zuc256_test_case_auth_1);
+}
+
+static int
+test_zuc256_authentication_test_case_2(void)
+{
+	return test_zuc_authentication(&zuc256_test_case_auth_2);
+}
+
 static int
 test_mixed_check_if_unsupported(const struct mixed_cipher_auth_test_data *tdata)
 {
@@ -14844,6 +14868,19 @@ static struct unit_test_suite cryptodev_zuc_testsuite  = {
 			test_zuc_auth_cipher_verify_test_case_1_sgl),
 		TEST_CASE_ST(ut_setup, ut_teardown,
 			test_zuc_auth_cipher_verify_test_case_1_oop_sgl),
+
+		/** ZUC-256 encrypt only **/
+		TEST_CASE_ST(ut_setup, ut_teardown,
+			test_zuc256_encryption_test_case_1),
+		TEST_CASE_ST(ut_setup, ut_teardown,
+			test_zuc256_encryption_test_case_2),
+
+		/** ZUC-256 authentication only **/
+		TEST_CASE_ST(ut_setup, ut_teardown,
+			test_zuc256_authentication_test_case_1),
+		TEST_CASE_ST(ut_setup, ut_teardown,
+			test_zuc256_authentication_test_case_2),
+
 		TEST_CASES_END()
 	}
 };
diff --git a/app/test/test_cryptodev_zuc_test_vectors.h b/app/test/test_cryptodev_zuc_test_vectors.h
index 2e330bc8d3..35bbe0f6c4 100644
--- a/app/test/test_cryptodev_zuc_test_vectors.h
+++ b/app/test/test_cryptodev_zuc_test_vectors.h
@@ -1299,4 +1299,290 @@ struct wireless_test_data zuc_auth_cipher_test_case_1 = {
 	}
 };
 
+/** ZUC-256 vectors **/
+static struct wireless_test_data zuc256_test_case_cipher_1 = {
+	.key = {
+		.data = {
+			0xf7, 0xb4, 0x04, 0x5a, 0x81, 0x5c, 0x1b, 0x01,
+			0x82, 0xf9, 0xf4, 0x26, 0x80, 0xd4, 0x56, 0x26,
+			0xd5, 0xf7, 0x4b, 0x68, 0x48, 0x6b, 0x92, 0x6a,
+			0x34, 0x1f, 0x86, 0x66, 0x60, 0x0a, 0xfc, 0x57
+		},
+		.len = 32
+	},
+	.cipher_iv = {
+		.data = {
+			0x8e, 0x5d, 0xbc, 0x3f, 0xb9, 0xae, 0x66, 0xa3,
+			0xb9, 0x5c, 0x12, 0x14, 0xdb, 0xc5, 0xbc, 0x18,
+			0x48, 0x92, 0x09, 0x86, 0x65, 0xb3, 0x2e, 0x92,
+			0x12
+		},
+		.len = 25
+	},
+	.plaintext = {
+		.data = {
+			0x36, 0xdb, 0x63, 0x68, 0xb5, 0x1f, 0x4e, 0x92,
+			0x46, 0x1f, 0xde, 0xdb, 0xc2, 0xec, 0xfa, 0x7e,
+			0x49, 0x85, 0x77, 0xaa, 0x46, 0x98, 0x30, 0x2d,
+			0x3b, 0xc4, 0x11, 0x24, 0x98, 0x20, 0xa9, 0xce,
+			0xfb, 0x0d, 0x36, 0xb0, 0x2c, 0x85, 0x42, 0x72,
+			0xa4, 0x21, 0x4e, 0x66, 0x0d, 0x48, 0xe4, 0x57,
+			0xce, 0x5b, 0x01, 0x14, 0xf3, 0x31, 0x42, 0x2e,
+			0xf5, 0x53, 0x52, 0x8d, 0x73, 0xfc, 0x5c, 0x6e,
+			0x09, 0x92, 0x1e, 0x35, 0x17, 0x60, 0xa8, 0xbb,
+			0x81, 0xf6, 0x21, 0x8f, 0x3e, 0x05, 0xe6, 0x0c,
+			0x60, 0xe7, 0x21, 0x53, 0x18, 0x63, 0x81, 0x0d,
+			0xb6, 0xd4, 0x9a, 0x29, 0xd0, 0xf6, 0x97, 0xd9,
+			0x89, 0xb5, 0x0e, 0xa0, 0x15, 0xb6, 0x5c, 0x97,
+			0xac, 0x7d, 0x26, 0xeb, 0x83, 0x0c, 0xf7, 0xe3,
+			0xf3, 0x18, 0x37, 0x0b, 0x7b, 0xb8, 0x18, 0x31,
+			0x8c, 0xb2, 0x5a, 0x5c, 0xa9, 0xf1, 0x35, 0x32
+		},
+		.len = 1024
+	},
+	.ciphertext = {
+		.data = {
+			0xa6, 0xe5, 0x71, 0x58, 0x5c, 0xcf, 0x5d, 0x0d,
+			0x59, 0xb5, 0x51, 0xab, 0xf5, 0xfa, 0x31, 0xf9,
+			0x8d, 0x4f, 0xf0, 0x3c, 0x7d, 0x61, 0x8d, 0x7a,
+			0x6b, 0xcb, 0x2c, 0x79, 0xca, 0x99, 0x06, 0x6f,
+			0xff, 0x5d, 0x12, 0x5f, 0x0e, 0x7a, 0x33, 0x6b,
+			0x51, 0xbc, 0x58, 0x53, 0xff, 0xbd, 0x85, 0xc9,
+			0xac, 0x5f, 0x33, 0xc2, 0xa2, 0xf1, 0x17, 0x7a,
+			0xd9, 0x3f, 0x81, 0x82, 0x2f, 0x0a, 0xb0, 0xaf,
+			0xb9, 0x19, 0x3b, 0xfa, 0xcd, 0xa4, 0x06, 0x81,
+			0x2a, 0x7a, 0xbf, 0x2c, 0x07, 0xde, 0xc1, 0xa4,
+			0x8c, 0x15, 0x85, 0x81, 0xa6, 0xd3, 0x73, 0x1c,
+			0x29, 0x0b, 0xee, 0x3c, 0x57, 0xfa, 0x82, 0xad,
+			0x6f, 0xe0, 0xa1, 0x54, 0x8d, 0xa4, 0x92, 0x29,
+			0xf4, 0xfa, 0x6d, 0x01, 0xe3, 0x6c, 0xb9, 0x76,
+			0x80, 0x53, 0xbb, 0x27, 0xb8, 0x18, 0x47, 0x6c,
+			0xae, 0xb5, 0x44, 0x60, 0x43, 0x9d, 0xa7, 0x3f
+		},
+		.len = 1024
+	},
+	.validDataLenInBits = {
+		.len = 1024
+	},
+	.validCipherLenInBits = {
+		.len = 1024
+	}
+};
+
+static struct wireless_test_data zuc256_test_case_cipher_2 = {
+	.key = {
+		.data = {
+			0x1d, 0x0f, 0x0e, 0x75, 0x86, 0xb3, 0xfc, 0x65,
+			0x94, 0xbf, 0xaa, 0xa8, 0xf5, 0xd0, 0x0f, 0xe8,
+			0x14, 0x7a, 0x96, 0x61, 0x15, 0x49, 0x79, 0x71,
+			0x13, 0x82, 0xb4, 0xae, 0x34, 0x04, 0x75, 0x51
+		},
+		.len = 32
+	},
+	.cipher_iv = {
+		.data = {
+			0x98, 0xcc, 0x89, 0x9f, 0xaf, 0x6d, 0x64, 0xb6,
+			0xb1, 0xe8, 0x21, 0x72, 0xee, 0xb6, 0xcc, 0xe3,
+			0xcf, 0xf2, 0x68, 0x61, 0xe1, 0x0d, 0x9e, 0xdc,
+			0x74
+		},
+		.len = 25
+	},
+	.plaintext = {
+		.data = {
+			0xa4, 0xcb, 0x6e, 0x76, 0x99, 0xfb, 0x0c, 0xab,
+			0x6d, 0x57, 0xb1, 0x69, 0xc0, 0x47, 0x80, 0x63,
+			0x00, 0xe1, 0xf9, 0x51, 0x10, 0xbe, 0xc0, 0x0f,
+			0x99, 0x62, 0x2d, 0x71, 0xca, 0x75, 0xa0, 0x6e,
+			0x41, 0x0e, 0xe4, 0xda, 0x09, 0xf1, 0x86, 0x76,
+			0x48, 0x37, 0xe0, 0x08, 0x7e, 0x60, 0x6c, 0x7f,
+			0x41, 0x65, 0xd0, 0x51, 0x24, 0x91, 0x61, 0xbd,
+			0xf3, 0x8e, 0x2e, 0xbd, 0x04, 0xce, 0x2b, 0x45,
+			0xdc, 0x0f, 0x1f, 0xe5, 0x00, 0xa5, 0x5c, 0x48,
+			0xdd, 0x3c, 0x51, 0x5b, 0x9c, 0xbd, 0xda, 0xde,
+			0x22, 0xab, 0x2f, 0x46, 0x3c, 0x90, 0x03, 0x2f,
+			0x1f, 0x31, 0xec, 0x23, 0xff, 0x17, 0x68, 0xdb,
+			0x26, 0x87, 0xc1, 0x27, 0x2d, 0x1d, 0x6f, 0x0a,
+			0x59, 0xc0, 0x65, 0xf5, 0x7d, 0x40, 0xd3, 0xa0,
+			0xeb, 0x03, 0xe6, 0x27, 0x93, 0xea, 0x56, 0xb2,
+			0x1b, 0x42, 0xd5, 0x1b, 0x59, 0x3d, 0xf6, 0x7f,
+			0xc5, 0xb7, 0xa6, 0xf2, 0xd4, 0x16, 0xfc, 0x2d,
+			0xd6, 0x61, 0x23, 0x54, 0xa1, 0xf6, 0xf4, 0x8c,
+			0xf9, 0xda, 0xb3, 0x8d, 0xc4, 0x09, 0x3f, 0xe0,
+			0x4b, 0x15, 0xfb, 0xa4, 0x52, 0xf1, 0x24, 0x17,
+			0xa9, 0xca, 0x09, 0x7d, 0xe0, 0x05, 0xab, 0xb7,
+			0x67, 0xce, 0x0b, 0x08, 0xc4, 0xff, 0x95, 0xbe,
+			0xd9, 0x48, 0x4b, 0x9e, 0x52, 0x8a, 0x7e, 0x9d,
+			0x9f, 0x79, 0x42, 0xf2, 0x6a, 0x66, 0x09, 0x13,
+			0x30, 0x13, 0x91, 0x11, 0x18, 0x3c, 0xc8, 0x7f,
+			0x0a, 0xd3, 0x88, 0xce, 0xd2, 0x1d, 0x8c, 0xab,
+			0x65, 0xd7, 0x49, 0xb7, 0x62, 0xc7, 0x55, 0x01,
+			0x40, 0x97, 0xf3, 0xab, 0xfd, 0xfd, 0xbe, 0x2d,
+			0x10, 0x4f, 0x3e, 0x28, 0x8b, 0x06, 0xa8, 0x95,
+			0xd9, 0x30, 0x64, 0xab, 0x4d, 0xf0, 0x57, 0xb2,
+			0xc8
+		},
+		.len = 1928
+	},
+	.ciphertext = {
+		.data = {
+			0xd0, 0xf9, 0xff, 0xce, 0x03, 0x81, 0x14, 0x9c,
+			0xd5, 0xf2, 0xbf, 0xe5, 0xff, 0xc8, 0x15, 0x4a,
+			0x9c, 0x06, 0x2b, 0x17, 0x99, 0xe3, 0x48, 0x70,
+			0x37, 0x01, 0x5e, 0x24, 0x80, 0x9a, 0x46, 0x4e,
+			0xa8, 0xc0, 0x59, 0xd7, 0x03, 0x74, 0x28, 0x91,
+			0x79, 0xb4, 0xb5, 0xd6, 0x52, 0x92, 0x04, 0x77,
+			0x5b, 0x4f, 0x34, 0xd1, 0xbe, 0xaa, 0x74, 0xd9,
+			0x01, 0x40, 0x24, 0xc7, 0x8c, 0x62, 0x2a, 0x51,
+			0x5a, 0x58, 0x0e, 0xc8, 0x70, 0x12, 0x06, 0x1c,
+			0x62, 0x7f, 0xf5, 0x23, 0xcb, 0x3c, 0xc1, 0xbe,
+			0x8b, 0x7f, 0x9d, 0x12, 0xb8, 0x26, 0xc8, 0xa3,
+			0x77, 0x7e, 0x83, 0xda, 0x83, 0xe1, 0x9f, 0xef,
+			0x33, 0x62, 0x17, 0xa7, 0x74, 0x68, 0x34, 0x5e,
+			0x16, 0xcc, 0xbc, 0x6c, 0x33, 0x2f, 0x73, 0xf0,
+			0xfc, 0xe5, 0x2c, 0x2d, 0xfb, 0x81, 0xbe, 0x1e,
+			0x6e, 0x4f, 0xf4, 0x14, 0x37, 0x7c, 0x97, 0xac,
+			0xa9, 0xac, 0x68, 0x95, 0xf3, 0x55, 0xb3, 0xfb,
+			0xf6, 0x64, 0xd9, 0x1b, 0xe1, 0x54, 0x79, 0x6e,
+			0xfa, 0x21, 0xa4, 0x19, 0x9f, 0xb4, 0x4b, 0xb7,
+			0xef, 0x52, 0xd8, 0x44, 0x75, 0x99, 0x07, 0x6d,
+			0xa9, 0xcf, 0x32, 0xc5, 0xc1, 0x31, 0x0c, 0xa8,
+			0x86, 0x40, 0x75, 0xeb, 0x12, 0xcf, 0x26, 0x5c,
+			0x5f, 0xa3, 0x3c, 0xb6, 0x12, 0x45, 0xf3, 0x0a,
+			0x38, 0x09, 0xa8, 0x36, 0x32, 0x4a, 0x2f, 0xad,
+			0x50, 0x11, 0x38, 0xba, 0x8f, 0xdd, 0xd1, 0x58,
+			0xd7, 0x3d, 0x3a, 0x40, 0x7c, 0x3f, 0xa7, 0x98,
+			0xf3, 0x12, 0x7f, 0x9f, 0x89, 0xcf, 0x48, 0x58,
+			0x01, 0xeb, 0x98, 0x7c, 0x59, 0x11, 0x9f, 0x57,
+			0x74, 0x5f, 0x70, 0x72, 0x74, 0xa4, 0x82, 0x3c,
+			0x36, 0xe6, 0x31, 0x9e, 0xba, 0x7b, 0x53, 0xfc,
+			0x56
+		},
+		.len = 1928
+	},
+	.validDataLenInBits = {
+		.len = 1928
+	},
+	.validCipherLenInBits = {
+		.len = 1928
+	}
+};
+
+static struct wireless_test_data zuc256_test_case_auth_1 = {
+	.key = {
+		.data = {
+			0xe3, 0x8e, 0xaf, 0x08, 0xde, 0x8c, 0x08, 0x41,
+			0x7f, 0x2b, 0x97, 0x20, 0x10, 0x87, 0xc7, 0xf7,
+			0xbe, 0x3c, 0xd2, 0x68, 0x80, 0x10, 0x1e, 0x71,
+			0xfd, 0xb2, 0xbb, 0xad, 0x25, 0x0f, 0x06, 0x08
+		},
+		.len = 32
+	},
+	.auth_iv = {
+		.data = {
+			0xf5, 0x8d, 0x08, 0x26, 0x94, 0x14, 0xc7, 0x4d,
+			0xf5, 0x7c, 0x9c, 0xaa, 0x45, 0x53, 0xfd, 0x85,
+			0x23, 0x8b, 0xc0, 0x4e, 0xa6, 0x2b, 0xcf, 0x41,
+			0xe6
+		},
+		.len = 25
+	},
+	.plaintext = {
+		.data = {
+			0x08, 0xba, 0x8d, 0xf1, 0xf8, 0x62, 0xa6, 0xaf,
+			0xf9, 0x03, 0x88, 0x9c, 0xa3, 0x68, 0x6b, 0x87,
+			0xb6, 0x92, 0xd1, 0x47, 0x3e, 0x54, 0xaf, 0x46,
+			0x07, 0x8f, 0x89, 0xea, 0x26, 0x9d, 0x0e, 0x2f,
+			0x57, 0x9b, 0x20, 0x4f, 0xfe, 0xc7, 0xfe, 0xf7,
+			0xca, 0x86, 0x93, 0x6d, 0xee
+		},
+		.len = 360
+	},
+	.validAuthLenInBits = {
+		.len = 360
+	},
+	.digest = {
+		.data = { 0x58, 0x19, 0xab, 0xa5 },
+		.len  = 4
+	}
+};
+
+static struct wireless_test_data zuc256_test_case_auth_2 = {
+	.key = {
+		.data = {
+			0x6a, 0x7e, 0x4c, 0x7e, 0x51, 0x25, 0xb3, 0x48,
+			0x84, 0x53, 0x3a, 0x94, 0xfb, 0x31, 0x99, 0x90,
+			0x32, 0x57, 0x44, 0xee, 0x9b, 0xbc, 0xe9, 0xe5,
+			0x25, 0xcf, 0x08, 0xf5, 0xe9, 0xe2, 0x5e, 0x53
+		},
+		.len = 32
+	},
+	.auth_iv = {
+		.data = {
+			0x60, 0xaa, 0xd2, 0xb2, 0xd0, 0x85, 0xfa, 0x54,
+			0xd8, 0x35, 0xe8, 0xd4, 0x66, 0x82, 0x64, 0x98,
+			0xd9, 0x2a, 0x08, 0x1d, 0x35, 0x19, 0x17, 0x01,
+			0x1A
+		},
+		.len = 25
+	},
+	.plaintext = {
+		.data = {
+			0xc6, 0x69, 0x73, 0x51, 0xff, 0x4a, 0xec, 0x29,
+			0xcd, 0xba, 0xab, 0xf2, 0xfb, 0xe3, 0x46, 0x7c,
+			0xc2, 0x54, 0xf8, 0x1b, 0xe8, 0xe7, 0x8d, 0x76,
+			0x5a, 0x2e, 0x63, 0x33, 0x9f, 0xc9, 0x9a, 0x66,
+			0x32, 0x0d, 0xb7, 0x31, 0x58, 0xa3, 0x5a, 0x25,
+			0x5d, 0x05, 0x17, 0x58, 0xe9, 0x5e, 0xd4, 0xab,
+			0xb2, 0xcd, 0xc6, 0x9b, 0xb4, 0x54, 0x11, 0x0e,
+			0x82, 0x74, 0x41, 0x21, 0x3d, 0xdc, 0x87, 0x70,
+			0xe9, 0x3e, 0xa1, 0x41, 0xe1, 0xfc, 0x67, 0x3e,
+			0x01, 0x7e, 0x97, 0xea, 0xdc, 0x6b, 0x96, 0x8f,
+			0x38, 0x5c, 0x2a, 0xec, 0xb0, 0x3b, 0xfb, 0x32,
+			0xaf, 0x3c, 0x54, 0xec, 0x18, 0xdb, 0x5c, 0x02,
+			0x1a, 0xfe, 0x43, 0xfb, 0xfa, 0xaa, 0x3a, 0xfb,
+			0x29, 0xd1, 0xe6, 0x05, 0x3c, 0x7c, 0x94, 0x75,
+			0xd8, 0xbe, 0x61, 0x89, 0xf9, 0x5c, 0xbb, 0xa8,
+			0x99, 0x0f, 0x95, 0xb1, 0xeb, 0xf1, 0xb3, 0x05,
+			0xef, 0xf7, 0x00, 0xe9, 0xa1, 0x3a, 0xe5, 0xca,
+			0x0b, 0xcb, 0xd0, 0x48, 0x47, 0x64, 0xbd, 0x1f,
+			0x23, 0x1e, 0xa8, 0x1c, 0x7b, 0x64, 0xc5, 0x14,
+			0x73, 0x5a, 0xc5, 0x5e, 0x4b, 0x79, 0x63, 0x3b,
+			0x70, 0x64, 0x24, 0x11, 0x9e, 0x09, 0xdc, 0xaa,
+			0xd4, 0xac, 0xf2, 0x1b, 0x10, 0xaf, 0x3b, 0x33,
+			0xcd, 0xe3, 0x50, 0x48, 0x47, 0x15, 0x5c, 0xbb,
+			0x6f, 0x22, 0x19, 0xba, 0x9b, 0x7d, 0xf5, 0x0b,
+			0xe1, 0x1a, 0x1c, 0x7f, 0x23, 0xf8, 0x29, 0xf8,
+			0xa4, 0x1b, 0x13, 0xb5, 0xca, 0x4e, 0xe8, 0x98,
+			0x32, 0x38, 0xe0, 0x79, 0x4d, 0x3d, 0x34, 0xbc,
+			0x5f, 0x4e, 0x77, 0xfa, 0xcb, 0x6c, 0x05, 0xac,
+			0x86, 0x21, 0x2b, 0xaa, 0x1a, 0x55, 0xa2, 0xbe,
+			0x70, 0xb5, 0x73, 0x3b, 0x04, 0x5c, 0xd3, 0x36,
+			0x94, 0xb3, 0xaf, 0xe2, 0xf0, 0xe4, 0x9e, 0x4f,
+			0x32, 0x15, 0x49, 0xfd, 0x82, 0x4e, 0xa9, 0x08,
+			0x70, 0xd4, 0xb2, 0x8a, 0x29, 0x54, 0x48, 0x9a,
+			0x0a, 0xbc, 0xd5, 0x0e, 0x18, 0xa8, 0x44, 0xac,
+			0x5b, 0xf3, 0x8e, 0x4c, 0xd7, 0x2d, 0x9b, 0x09,
+			0x42, 0xe5, 0x06, 0xc4, 0x33, 0xaf, 0xcd, 0xa3,
+			0x84, 0x7f, 0x2d, 0xad, 0xd4, 0x76, 0x47, 0xde,
+			0x32, 0x1c, 0xec, 0x4a, 0xc4, 0x30, 0xf6, 0x20,
+			0x23, 0x85, 0x6c, 0xfb, 0xb2, 0x07, 0x04, 0xf4,
+			0xec, 0x0b, 0xb9, 0x20, 0xba, 0x86, 0xc3, 0x3e,
+			0x05, 0xf1, 0xec, 0xd9, 0x67, 0x33, 0xb7, 0x99,
+			0x50, 0xa3, 0xe3, 0x14, 0xd3, 0xd9, 0x34, 0xf7,
+			0x5e, 0xa0, 0xf2, 0x10, 0xa8, 0xf6, 0x05, 0x94,
+			0x01, 0xbe, 0xb4, 0xbc, 0x44, 0x78, 0xfa, 0x49,
+			0x69, 0xe6, 0x23, 0xd0, 0x1a, 0xda, 0x69
+		},
+		.len = 2872
+	},
+	.validAuthLenInBits = {
+		.len = 2872
+	},
+	.digest = {
+		.data = { 0xd1, 0x1e, 0x33, 0xf6 },
+		.len  = 4
+	}
+};
+
 #endif /* TEST_CRYPTODEV_ZUC_TEST_VECTORS_H_ */